package chapter4.basics;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.geometry.*;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.*;
import javafx.scene.layout.*;

public class Counter extends Application
{
    private Label label;
    private int counter;

    private void increment()
    {
        counter++;
        label.setText("" + counter);
    }

    private void reset()
    {
        counter = 0;
        label.setText("" + counter);
    }

    public void start(Stage primaryStage)
    {
        label = new Label();
        Button b1 = new Button("Erhhen");
        b1.setOnAction((ActionEvent e) -> increment());
        Button b2 = new Button("Zurcksetzen");
        b2.setOnAction(e -> reset());
        VBox root = new VBox(10);
        Insets padding = new Insets(10);
        root.setPadding(padding);
        root.setAlignment(Pos.BOTTOM_RIGHT);
        root.setFillWidth(true);
        VBox.setVgrow(b1, Priority.ALWAYS);
        b1.setMaxHeight(Double.MAX_VALUE);
        b2.setMaxWidth(Double.MAX_VALUE);
        root.getChildren().add(label);
        root.getChildren().add(b1);
        root.getChildren().add(b2);
        reset();

        Scene scene = new Scene(root);
        primaryStage.setScene(scene);
        primaryStage.setTitle("Zhler");
        primaryStage.show();
    }

    public static void main(String[] args)
    {
        launch(args);
    }
}
