package tutorial.chat;

import java.io.StringReader;
import java.util.Date;
import javax.json.Json;
import javax.json.JsonObject;
import javax.websocket.DecodeException;
import javax.websocket.Decoder;
import javax.websocket.EndpointConfig;

public class ChatMessageDecoder implements Decoder.Text<ChatMessage>
{
    @Override
    public void init(EndpointConfig config)
    {
    }

    @Override
    public void destroy()
    {
    }

    @Override
    public ChatMessage decode(String textMessage) throws DecodeException
    {
        System.out.println("decoded: " + textMessage);
        ChatMessage chatMessage = new ChatMessage();
        JsonObject obj = Json.createReader(new StringReader(textMessage)).readObject();
        chatMessage.setMessage(obj.getString("message"));
        chatMessage.setSender(obj.getString("sender"));
        chatMessage.setReceived(new Date());
        return chatMessage;
    }

    @Override
    public boolean willDecode(String s)
    {
        return true;
    }
}